//---------------------------------------------------------------------------
#include <vcl.h>
#include <windows.h>
#pragma hdrstop

// Exported functions
extern "C" __declspec(dllexport)bool InstallMouseHook();
extern "C" __declspec(dllexport)bool RemoveMouseHook();

// Declarations
LRESULT CALLBACK MouseProc(int code, WPARAM wParam, LPARAM lParam);

// Global variables
HHOOK HookHandle;
HINSTANCE DllInstance;
bool IsInRect=false;

//---------------------------------------------------------------------------
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
  DllInstance=hinst;
  return 1;
}
//---------------------------------------------------------------------------
bool InstallMouseHook()
{
  HookHandle=SetWindowsHookEx(WH_MOUSE,
      reinterpret_cast<HOOKPROC>(MouseProc),DllInstance,0);
  if (HookHandle==NULL)return false;
  else return true;
}
//---------------------------------------------------------------------------
bool RemoveMouseHook()
{
  if(UnhookWindowsHookEx(HookHandle)==0)
  {
    return false;
  }
  else return true;
}
//---------------------------------------------------------------------------
LRESULT CALLBACK MouseProc(int code, WPARAM wParam, LPARAM lParam)
{
  if (code<0)
  {
    return CallNextHookEx(HookHandle,code,wParam,lParam);
  }
  POINT MousePos;
  RECT UpperRightCorner=Rect(Screen->Width-2,0,Screen->Width,2);
  GetCursorPos(&MousePos);
  if((PtInRect(&UpperRightCorner,MousePos))&&(IsInRect==false))
  {
    IsInRect=true;
    PROCESS_INFORMATION piProcInfo;
    STARTUPINFO siStartInfo;
    memset(&siStartInfo,NULL,sizeof(STARTUPINFO));
    siStartInfo.cb=sizeof(STARTUPINFO);
    CreateProcess(NULL,"C:\\Microsoft Office\\Office\\OSA.EXE -s",
                NULL,NULL,0,0,NULL,NULL,&siStartInfo,&piProcInfo);
  }
  else IsInRect=false;
  return CallNextHookEx(HookHandle,code,wParam,lParam);
}
//---------------------------------------------------------------------------
